package controller

import (
	"enterprise/common/config"
	"enterprise/common/dao"
	"enterprise/server/api"
	"enterprise/server/service"
	"enterprise/server/session"
	"github.com/gin-gonic/gin"
	"net/http"
)

type Pay struct {
}

func NewPay() *Pay {
	return &Pay{}
}
func (q *Pay) Pay(ctx *gin.Context) {
	sess := ctx.Keys[session.ContextSession].(*session.AdminSession)
	corp, err := dao.NewCorpDao().GetByHost(sess.GetHeader().Host)
	session.CheckDBError(err)
	session.CheckNilError(corp, "域名未绑定")

	var req api.PayReq
	session.CheckParamError(ctx.ShouldBindJSON(&req))

	if req.Password != corp.GetConfig().Password {
		panic(config.ErrParam.New().Append("密码错误"))
	}

	service.NewPay().Pay(corp, &req)
	ctx.JSON(http.StatusOK, session.NewRspOk())
}
